/* ##### rradminmediasearch_config.js, installed by ###Admin Media Search, by Robin Richmond */
/* Functions used by the Admin Media Search mod options in admin_genconfig.php */

$(function() {
	var onOff;
	$(".rramsSearch input").click(function() {
		$("#rramsNativeSearchButton").prop('disabled',false);
		$("#rramsRecommendedSearchButton").prop('disabled',false);
	});
	$("#rramsSearchTable").click(function() {
		$("#rramsNativeSearchButton").prop('disabled',false);
		$("#rramsRecommendedSearchButton").prop('disabled',false);
		$("#rramsNativeSearchHint").hide();
		$("#rramsRecommendedSearchHint").hide();
	});
	onOff = $("input[name='rrconfig[MediaShowSearchableFields]'][value='1']").is(':checked');
	rramsSearchCheckboxStatus(onOff);

	$(".rramsColumns input").click(function() {
		$("#rramsNativeColumnsButton").prop('disabled',false);
		$("#rramsRecommendedColumnsButton").prop('disabled',false);
	});
	$("#rramsColumnsTable").click(function() {
		$("#rramsNativeColumnsButton").prop('disabled',false);
		$("#rramsRecommendedColumnsButton").prop('disabled',false);
		$("#rramsNativeColumnsHint").hide();
		$("#rramsRecommendedColumnsHint").hide();
	});
	onOff = $("input[name='rrconfig[MediaAllowOptionalColumns]'][value='1']").is(':checked');
	rramsColumnsStatus(onOff);
});

//////////////////// Media Search Fields ////////////
// Hide/Show Buttons onclick that toggles the Media Search Fields
function rramsToggleSearch() {
	$('.rramsSearch').toggle();
	return false;
}
//Set the native Search field options, which are
//Do not list the searchable fieldnames, and, of course, don't show checkboxes.
//The searchable fields are listed below; all are searched by default
function rramsSetNativeSearch() {
	$("input[name='rrconfig[MediaShowSearchableFields]'][value='0']").prop('checked',true);
	$("input[name='rrconfig[MediaShowSearchCheckboxes]'][value='0']").prop('checked',true);
	//Remove all existing fields from the table of fields to search
	$("#rramsSearchTable>tbody>tr").each(function() {
		var rowNum = $(this).prop('id').replace('rrmsdbrow','');
		rramsRemoveSearchField(rowNum);
	});
	//Add these specific fields
	rramsAddSearchableField('mediaID', 1);
	rramsAddSearchableField('description',1);
	rramsAddSearchableField('notes', 1);
	rramsAddSearchableField('path', 1);
	rramsAddSearchableField('bodytext', 1);
	rramsAddSearchableField('owner', 1);
	//Activate the Recommended button & Hide the Recommended hint.
	$("#rramsRecommendedSearchButton").prop('disabled',false);
	$("#rramsRecommendedSearchHint").hide();
	//Deactivate the Native button
	$("#rramsNativeSearchButton").prop('disabled',true);
	rramsSearchCheckboxStatus(0);
} //End function rramsSetNativeSearch

//Set the recommended search Field options, which are
//List the searchable fields, Give them checkboxes,
//The searchable fields are specified below; 3 of them are searched by default
function rramsSetRecommendedSearch() {
	$("input[name='rrconfig[MediaShowSearchableFields]'][value='1']").prop('checked',true);
	$("input[name='rrconfig[MediaShowSearchCheckboxes]'][value='1']").prop('checked',true);
	rramsSearchCheckboxStatus(1);
	$("#rramsSearchTable>tbody>tr").each(function() {
		var rowNum = $(this).prop('id').replace('rrmsdbrow','');
		rramsRemoveSearchField(rowNum);
	});
	rramsAddSearchableField('description', 1);
	rramsAddSearchableField('notes', 1);
	rramsAddSearchableField('bodytext', 1);
	rramsAddSearchableField('path', 0);
	rramsAddSearchableField('mediaID', 0);
	//Activate the Native button & Hide the Native hint.
	$("#rramsNativeSearchButton").prop('disabled',false);
	$("#rramsNativeSearchHint").hide();
	//Deactivate the Recommended button
	$("#rramsRecommendedSearchButton").prop('disabled',true);
} //End function rramsSetRecommendedSearch

// (de)activate the Show Search Field Checkboxes option
function rramsSearchCheckboxStatus(onOff) {
	if (onOff) {
		$("input[name='rrconfig[MediaShowSearchCheckboxes]']").prop('disabled',false);
		$('.rramsSearchCheckboxYes').removeClass('rramsDisabled');
		$('.rramsSearchCheckboxNo').addClass('rramsDisabled');
		$('.rramsSearchPromptYes').show();
		$('.rramsSearchPromptNo').hide();
	} else {
		$("input[name='rrconfig[MediaShowSearchCheckboxes]']").prop('disabled',true);
		$('.rramsSearchCheckboxYes').addClass('rramsDisabled');
		$('.rramsSearchCheckboxNo').removeClass('rramsDisabled');
		$('.rramsSearchPromptYes').hide();
		$('.rramsSearchPromptNo').show();
	}
}	

//Onclick function for the 'Select a fieldname' dropdown box below the Search Fields table.
//The "Add Searchable Field" button is enabled only if a field has been selected.
function rramsValidateNewFields() {
	var newFieldname = $('#rramsNewFieldname').val();
	if (newFieldname) $('#rramsAddButton').prop('disabled',false);
	else $('#rramsAddButton').prop('disabled',true);
} //end function rramsValidateNewFields

//Onclick function for the "Add Searchable Field" button below the Search Fields table
//Adds a row to the Searchable Fields table for the "Select a fieldname" selection.
//The 'checked' parameter specifies whether to check this fieldname's default button.
function rramsAddSearchableField(fieldname, checkit) {
	var checked = checkit ? ' checked' : '';
	var remove = $('#rramsRemove').text();
	var rowNum = 0;
	if ($('#rramsSearchTable tbody').children().length) {
		var lastExistingRowID = $('#rramsSearchTable tbody').children().last().prop('id');
		rowNum = lastExistingRowID.replace('rrmsdbrow','');
	}
	++rowNum;
	
	var html = "<tr id='rrmsdbrow"+rowNum+"'><td>" + fieldname +
		"<input type='hidden' name='rrMediaSearchableFieldList["+rowNum+"]'" +
			" id='rramsfname"+rowNum+"' value='"+fieldname+"'></td>" +
		"<td class='rrMediaShowSearchCheckboxes'><input type='checkbox'" +
			" name='rrMediaSearchCheckboxes["+rowNum+"]' id='rrmsfcheckbox"+rowNum+"'" +
			" value='1'" + checked + "></td>" +
		"<td><input type='button' class='smaller' id='remove"+rowNum+"'" +
			" value='" + remove + "'" +
			" onclick='return rramsRemoveSearchField("+rowNum+");'></td>" +
		"</tr>";
	$('#rramsSearchTable tbody').append(html);
	$('#rramsAddButton').prop('disabled',true); //Disable the Add New button
	$('#rramsNewFieldname').val(''); //Clear the New Fieldname selection box.
	//The fieldname that we just added must be removed from the options.
	$('#rramsNewFieldname option').each(function() {
		if ($(this).val() == fieldname) {
			$(this).remove();
			return;
		}
	});
} //end function rramsAddSearchableField

//Onclick function for a Remove button
function rramsRemoveSearchField(rowNumber) {
	var fieldname = $('#rramsfname'+rowNumber).val();
	//Add the fieldname to the selection list
	$('#rramsNewFieldname').append("<option>"+fieldname+"</option>")
	//Remove the table row
	$('#rrmsdbrow'+rowNumber).remove();
	return false;
} //end function rramsRemoveSearchField

////////////////////////////////////////////////////////
///////////////// Optional Results Columns /////////////
////////////////////////////////////////////////////////
// Toggle the block based on the "Show/Hide Settings" buttons
function rramsToggleColumns() {
	$('.rramsColumns').toggle();
	return false;
}

//Set the native Optional Results options
function rramsSetNativeColumns() {
//Don't ever display the filetype in the 'Title/Description' column
//Prohibit all possible optional columns, and, of course, none of them are defaults.
	$("input[name='rrconfig[MediaShowExtWYes]'][value='0']").prop('checked',true);
	$("input[name='rrconfig[MediaShowExtWNo]'][value='0']").prop('checked',true);
	//Set the status of the checkboxes in the table of optional column names
	$(".rramsOfferedColumns").prop('checked',false);
	$(".rramsDefaultColumns").prop('checked',false);
	$("#rramsOfferedGeocodes").prop('checked',true);
	$("#rramsDefaultGeocodes").prop('checked',true);
	//Activate the Recommended button & Hide the Recommended hint.
	$("#rramsRecommendedColumnsButton").prop('disabled',false);
	$("#rramsRecommendedColumnsHint").hide();
	//Deactivate the Native button
	$("#rramsNativeColumnsButton").prop('disabled',true);
	//Show & hide the appropriate fields and hints
	rramsColumnsStatus(0);
} //End function rramsSetNativeColumns

//Set the recommends Optional Results options, which are
//Do display the filetype in the Title/Description' column if there is no filepath column
//Allow all possible optional columns, but check none of them by default
function rramsSetRecommendedColumns() {
	$("input[name='rrconfig[MediaShowExtWYes]'][value='1']").prop('checked',true);
	$("input[name='rrconfig[MediaShowExtWNo]'][value='1']").prop('checked',true);
	//Set the status of the checkboxes in the table of optional column names
	$(".rramsOfferedColumns").prop('checked',true);  //Everything is offered
	$("#rramsOfferedmediakey").prop('checked',false);//Except mediakey
	$(".rramsDefaultColumns").prop('checked',false); //Nothing is set as default 
	//Deactivate the Native button & hide the Native hint.
	$("#rramsNativeColumnsButton").prop('disabled',false);
	$("#rramsNativeColumnsHint").hide();
	//Deactivate the Recommended button
	$("#rramsRecommendedColumnsButton").prop('disabled',true);
	//Show & hide the appropriate fields and hints
	rramsColumnsStatus(1);
} //End function rramsSetRecommendedColumns

// (de)activate the Optional Columns sub-options
//YesNo=1 means activate the YES options, deactivate NO; 0 means the opposite	
function rramsColumnsStatus(yesNo) {
	if (yesNo){
		$("input[name='rrconfig[MediaShowExtWYes]']").prop('disabled',false);
		$("input[name='rrconfig[MediaShowExtWNo]']").prop('disabled',true);
		$("#input[name='rrconfig[MediaShowExtWNo]']").prop('disabled',true);
		//Set the status of the checkboxes in the table of optional column names
		$('.rramsOfferedColumns').prop('disabled',false);
		$('.rramsDefaultColumns').prop('disabled',false);
		//Display the Yes note & table clearly, and grey-out the No note.
		$('#rramsColumnsTable').removeClass('rramsDisabled')
		$('.rramsColumnsYes').removeClass('rramsDisabled');
		$('.rramsColumnsNo').addClass('rramsDisabled');
		//$("#rramsNativeColumnsHint").addClass('rramsDisabled');;
	} else {
		$("input[name='rrconfig[MediaShowExtWYes]']").prop('disabled',true);
		$("input[name='rrconfig[MediaShowExtWNo]']").prop('disabled',false);
		$('.rramsColumnsNo').removeClass('rramsDisabled');
		//Set the status of the checkboxes in the table of optional column names
		$('#rramsColumnsTable input').prop('disabled',true);
		//Grey out the Yes options, including the table of optional column names
		$('.rramsColumnsYes').addClass('rramsDisabled');
		$('#rramsColumnsTable').addClass('rramsDisabled')
		//$("#rramsNativeColumnsHint").hide();
	}
	return false;
} //end function rramsResultColumnsStatus

////////////////////////////////////////////////////////
////////////// Thumbnail Column Extra Info /////////////
////////////////////////////////////////////////////////
// Onclick for the Thumbnail Extra Info "Show/Hide Settings" buttons
function rramsToggleThumb() {
	$('.rramsThumb').toggle();
	return false;
}

//Set the native Thumbnail options
function rramsSetNativeThumb() {
	$("input[name='rrconfig[MediaThumbFiletypes]'][value='0']").prop('checked',true);
	$("input[name='rrconfig[MediaThumbExtErrors]'][value='0']").prop('checked',true);
	$("input[name='rrconfig[MediaThumbFormErrors]'][value='0']").prop('checked',true);
} //End function rramsSetNativeThumb

//Set the recommended Thumnail options
function rramsSetRecommendedThumb() {
	$("input[name='rrconfig[MediaThumbFiletypes]'][value='1']").prop('checked',true);
	$("input[name='rrconfig[MediaThumbExtErrors]'][value='0']").prop('checked',true);
	$("input[name='rrconfig[MediaThumbFormErrors]'][value='0']").prop('checked',true);
} //End function rramsSetRecommendedThumb

////////////////////////////////////////////////////////
///////////// Citation Medialink Event Tags ////////////
////////////////////////////////////////////////////////
// Onclick to toggle the Citation Medialink radio buttons
function rramsToggleCite() {
	$('.rramsCite').toggle();
	return false;
}

//Set the native Citation Medialink option
function rramsSetNativeCite() {
	$("#rramsCiteNever").prop('checked',true);
} //End function rramsSetNativeCite

//Set the recommended Citation Medialink option
function rramsSetRecommendedCite() {
	$("#rramsCiteWithout").prop('checked',true);
} //End function rramsSetRecommendedCite


