<?php
##### rradminmediasearch_config.php, installed by ###Admin Media Search, by Robin Richmond
# This mod installs so much code that I decided to put the code in this Include file.
# At a high level, this file does that same thing as my other mods that define Mod Settings Block.
# What makes it distinct are the number and complexity of the options, which
# - Use buttons to open and close blocks of options
# - Use buttons to set the options to make the code act like the native code, 
#   and to set "recommended" options.
# - Have several fields whose values disable or enable subordinate options.
# - Grey-out the labels of disabled options.
# - Include an "inner" table that lists the database fields that are (or can be) searched,
#   along with a checkbox that determines whether they are checked by default.
#   In this table, database field can be added and removed.
# - Include a table that lists optional columns that can be included in the
#   search results, along with checkboxes that determine whether the column is
#   included by default.
# - Use A LOT of Javascript code, which is in its own file, js/rradminmediasearch.js.
# - Use yes/no radio buttons instead of checkboxes, except inside the inner tables
#   so that the native and recommended options can be highlighlighted.
#   (The fields have classes that allow native and recommended options to be highlighted,
#    but the code that would actually highlight them is not implemented. Basically,
#    I just didn't come up with a satisfactory place to put buttons that would activate
#    the highlighting.)

### Initialize undefined options ###
# Search fields
if (!isset($rrconfig['MediaShowSearchableFields'])) $rrconfig['MediaShowSearchableFields'] = 1;
if (empty($rrconfig['MediaSearchableFields']))
	$rrconfig['MediaSearchableFields'] = 'description,notes,mediaID,path,bodytext';
if (empty($rrconfig['MediaSearchDefault']))
	$rrconfig['MediaSearchDefault'] = 'description,notes';
if (!isset($rrconfig['MediaShowSearchCheckboxes'])) $rrconfig['MediaShowSearchCheckboxes'] = 1;
# "Has Bodytext checkbox.
if (!isset($rrconfig['MediaRequireBodytext'])) $rrconfig['MediaRequireBodytext'] = 1;
# Sort options
if (!isset($rrconfig['MediaAllowSortOptions'])) $rrconfig['MediaAllowSortOptions'] = 1;
#Event tags associated with citation medialinks
if (empty($rrconfig['MediaShowCiteTags'])) $rrconfig['MediaShowCiteTags'] = 'togglenot';
# Optional Results Columns
if (!isset($rrconfig['MediaAllowOptionalColumns'])) $rrconfig['MediaAllowOptionalColumns'] = 1;
if ($rrconfig['MediaAllowOptionalColumns']) {
	if (empty($rrconfig['MediaOfferedColumns'])) $rrconfig['MediaOfferedColumns'] = 'mediaid,path,geocodes';
	if (empty($rrconfig['MediaDefaultColumns'])) $rrconfig['MediaDefaultColumns'] = '';
} else {
	if (empty($rrconfig['MediaOfferedColumns'])) $rrconfig['MediaOfferedColumns'] = '';
	if (empty($rrconfig['MediaDefaultColumns'])) $rrconfig['MediaDefaultColumns'] = 'geocodes';
}
# Show filetype in the Title/Description column
if (!isset($rrconfig['MediaShowFiletype'])) $rrconfig['MediaShowFiletype'] = 1;
# Additional Information in the Thumbnail Column
if (!isset($rrconfig['MediaThumbFiletypes'])) $rrconfig['MediaThumbFiletypes'] = 1;
if (!isset($rrconfig['MediaThumbExtErrors'])) $rrconfig['MediaThumbExtErrors'] = 0;
if (!isset($rrconfig['MediaThumbFormErrors'])) $rrconfig['MediaThumbFormErrors'] = 0;

##### Start the configuration table. For this mod, the configuration table is just one column wide.
echo "<table class='rrConfigTable' modname='Admin Media Search' group='Media'>
	<tbody class='rrams'>
	<input type='hidden' name='rrconfig[Admin Media Search]'
		value='MediaShowSearchableFields, MediaShowSearchCheckboxes, MediaRequireBodytext, MediaAllowSortOptions, MediaAllowOptionalColumns, MediaShowFiletype, MediaThumbFiletypes, MediaThumbExtErrors, MediaThumbFormErrors, MediaShowCiteTags'>\n";

	######################################################
	############### Optional Search Fields ###############
	######################################################
	#'Native', 'Recommended' and 'View/Hide' buttons
	echo "<tr><td style='border:solid blue 2px;text-align:left;'>
		1. {$admtext['rrams-changesearchfields']}:<br>
			<input type='button' class='small' value='{$admtext['rrams-seenative']}' 
				id='rramsNativeSearchButton'
				onclick=\"$('#rramsNativeSearchHint').toggle();\">
			&ensp;<input type='button' class='small' value='{$admtext['rrams-seerecommended']}' 
				id='rramsRecommendedSearchButton'
				onclick=\"$('#rramsRecommendedSearchHint').toggle();\">\n";
			#The show and hide buttons
			echo "&ensp;<input type='button' class='rramsSearch small' 
				value='{$admtext['rrams-showsettings']}' onclick='rramsToggleSearch();'>
			<input type='button' class='rramsSearch small' value='{$admtext['rrams-hidesettings']}'
				onclick='rramsToggleSearch();' style='display:none;'>\n";
		#Hint text for the Native Settings and Recommended Settings buttons.
		echo "<fieldset id='rramsNativeSearchHint' style='display:none;'>
			<legend>{$admtext['rrams-native']}</legend>
			{$admtext['rrams-nativesearchshint']}&nbsp;<input type='button' value='Apply'
			class='small' onclick='return rramsSetNativeSearch()'></fieldset>\n";
		echo "<fieldset id='rramsRecommendedSearchHint' style='display:none;'>
			<legend>{$admtext['rrams-recommended']}</legend>
			{$admtext['rrams-recommendedsearchhint']}&nbsp;<input type='button' value='Apply' 
			class='small' onclick='return rramsSetRecommendedSearch()'></fieldset>\n";

		###Block of fields subordinate to and toggled by the "Change search fields..." buttons
		echo "<div class='rramsSearch' style='margin-left:2em;display:none;'>\n";
			### Show searchable Fields
			if ($rrconfig['MediaShowSearchableFields']) {$checkedy=' checked'; $checkedn='';}
			else {$checkedy=''; $checkedn=' checked';}
			echo "{$admtext['rrams-showfields']}:
				<label class='rramsRecommended'><input type='radio' value='1'$checkedy
					name='rrconfig[MediaShowSearchableFields]'
					onclick='return rramsSearchCheckboxStatus(1);'>{$admtext['yes']}</label> &ensp;
				<label class='rramsNative'><input type='radio' value='0'$checkedn 
					name='rrconfig[MediaShowSearchableFields]'
					onclick='return rramsSearchCheckboxStatus(0);'>{$admtext['no']}</label>\n";

			### Show searchable field checkboxes - subordinate to Show Searchable fields
			echo "<div class='rramsSearchCheckboxYes' style='margin-left:2em;'>\n";
				if ($rrconfig['MediaShowSearchCheckboxes']) {$checkedy=' checked'; $checkedn='';}
				else {$checkedy=''; $checkedn=' checked';}
				echo "{$admtext['rrams-showcheckboxes']}:
				<label class='rramsRecommended'><input type='radio' value='1'$checkedy 
					name='rrconfig[MediaShowSearchCheckboxes]'>{$admtext['yes']}</label> &nbsp;
				<label class='rramsNative'><input type='radio' value='0'$checkedn	
					name='rrconfig[MediaShowSearchCheckboxes]'>{$admtext['no']}</label>";
			echo "</div>\n";
			#### Use a function to display the table of options for the searchable fields.
			echo "<div style='margin-top:4px;'>", rrDisplaySearchTable(), "</div>\n";
		echo "</div>
		</td></tr>\n";

	######################################################
	############# Has BodyText & Allow Sort  #############
	######################################################
	echo "<tr><td style='text-align:left;'>\n";
		#### Whether to have the option to require bodytext
		if ($rrconfig['MediaRequireBodytext']) {$checkedy=' checked'; $checkedn='';}
		else {$checkedy=''; $checkedn=' checked';}
		echo "<div>2. {$admtext['rrams-requirebodytext']}:
			<label><input type='radio' name='rrconfig[MediaRequireBodytext]' value='1'
				$checkedy><span class='rramsRecommended'>{$admtext['yes']}</label> &nbsp;
			<label><input type='radio' name='rrconfig[MediaRequireBodytext]' value='0'
				$checkedn><span class='rramsNative'>{$admtext['no']}</label>
			</div>\n";
		#### Whether to have sort options
		if ($rrconfig['MediaAllowSortOptions']) {$checkedy=' checked'; $checkedn='';}
		else {$checkedy=''; $checkedn=' checked';}
		echo "<div>3. {$admtext['rrams-showsortoptions']}:
			<label class='rramsRecommended'><input type='radio' value='1'$checkedy
				name='rrconfig[MediaAllowSortOptions]'>{$admtext['yes']}</label> &nbsp;
			<label class='rramsNative'><input type='radio' value='0'$checkedn
				name='rrconfig[MediaAllowSortOptions]'>{$admtext['no']}</label>
			</div>\n";
	echo "</td></tr>\n";

	############################################################
	################ Optional Results Columns  #################
	############################################################
	### Native/Recommended/Show/Hide Settings buttons
	echo "<tr><td style='border:solid orange 2px;text-align:left;'>
		4. {$admtext['rrams-optionalresultscolumns']}:<br>
			<input type='button' value='{$admtext['rrams-seenative']}' id='rramsNativeColumnsButton'
				class='small' onclick=\"$('#rramsNativeColumnsHint').toggle();\">
			&ensp;<input type='button' value='{$admtext['rrams-seerecommended']}' id='rramsRecommendedColumnsButton'
				class='small' onclick=\"$('#rramsRecommendedColumnsHint').toggle();\"'>\n";
			#The show and hide buttons
			echo "&ensp;<input type='button' class='rramsColumns small' value='{$admtext['rrams-showsettings']}'
				onclick='rramsToggleColumns();'>
			<input type='button' class='rramsColumns small' value='{$admtext['rrams-hidesettings']}'
				onclick='rramsToggleColumns();' style='display:none;'>\n";
		#Hint text for the Native Settings and Recommended Settings buttons.
		echo "<fieldset id='rramsNativeColumnsHint' style='display:none;'>
			<legend>{$admtext['rrams-native']}</legend>
			{$admtext['rrams-nativeresultshint']}&nbsp;<input type='button' value='Apply'
			class='small' onclick='return rramsSetNativeColumns()'></fieldset>\n";
		echo "<fieldset id='rramsRecommendedColumnsHint' style='display:none;'>
			<legend>{$admtext['rrams-recommended']}</legend>
			{$admtext['rrams-recommendedresultshint']}&nbsp;<input type='button' value='Apply' 
			class='small' onclick='return rramsSetRecommendedColumns()'></fieldset>\n";

		#Block of fields subordinate to and toggled by the "Optional Results Columns" buttons.
		echo "<div class='rramsColumns' style='margin-left:2em;display:none'>\n";
			####First subordinate option - Allow optional results columns
			if ($rrconfig['MediaAllowOptionalColumns']) {$checkedy=' checked'; $checkedn='';}
			else {$checkedy=''; $checkedn=' checked';}
			echo "{$admtext['rrams-allowoptionalcolumns']}:\n";
			#Indent the yes/no radio buttons
			echo "<div style='margin-left:2em;'>\n";
				echo "<label class='rramsRecommended'><input type='radio' value='1'$checkedy
					name='rrconfig[MediaAllowOptionalColumns]'
					onclick='rramsColumnsStatus(1);'>{$admtext['yes']}
					&ensp;<span class='rramsColumnsYes'>{$admtext['rrams-resultsyes']}<span></label>\n";
					###Subordinate to the YES option
					echo "<div class='rramsColumnsYes' style='margin-left:2em;'>\n";
						# Use a function to display the options for the optional columns.
						echo "<div style='margin-top:4px;'>", rrDisplayColumnsOptions(), "</div>\n";
					echo "</div>\n";
				#Back to the "No" radio button for the "Allow Optional Columns"
				echo "<label class='rramsNative'><input type='radio' value='0'$checkedn 
					name='rrconfig[MediaAllowOptionalColumns]'
					onclick='rramsColumnsStatus(0)''>{$admtext['no']}
					&ensp;<span class='rramsColumnsNo'>{$admtext['rrams-resultsno']}<span></label>\n";
			echo "</div>\n"; #End yes/no radio buttons
		echo "</div>\n"; #End results column option
	echo "</td></tr>\n;"; #End result column options

	##############################################################
	############ File Extension in Title/Description #############
	##############################################################
	echo "<tr><td style='text-align:left;'>\n";
		if ($rrconfig['MediaShowFiletype']) {$checkedy=' checked'; $checkedn='';}
		else {$checkedy=''; $checkedn=' checked';}
		echo "5. {$admtext['rrams-showfiletypeprompt']}:
			<label class='rramsRecommended'><input type='radio' name='rrconfig[MediaShowFiletype]'
				value='1'$checkedy >{$admtext['yes']}</label>
			<label class='rramsNative'><input type='radio' name='rrconfig[MediaShowFiletype]'
				value='0'$checkedn>{$admtext['no']}</label>\n";
	echo "</td></tr>\n";

	######################################################
	############ Thumbnail Column Extra Info #############
	######################################################
	echo "<tr><td style='border:solid brown 2px;text-align:left;'>
		6. {$admtext['rrams-extrathumbinfo']}:<br>
			<input type='button' class='small' value='{$admtext['rrams-seenative']}' 
				id='rramsNativeThumbButton'
				onclick=\"$('#rramsNativeThumbHint').toggle();\">
			&ensp;<input type='button' class='small' value='{$admtext['rrams-seerecommended']}' 
				id='rramsRecommendedThumbButton'
				onclick=\"$('#rramsRecommendedThumbHint').toggle();\">\n";
			#The show and hide buttons
			echo "&ensp;<input type='button' class='rramsThumb small' 
				value='{$admtext['rrams-showsettings']}' onclick='rramsToggleThumb();'>
			<input type='button' class='rramsThumb small' value='{$admtext['rrams-hidesettings']}'
				onclick='rramsToggleThumb();' style='display:none;'>\n";
		#Hint text for the Native Settings and Recommended Settings buttons.
		echo "<fieldset id='rramsNativeThumbHint' style='display:none;'>
			<legend>{$admtext['rrams-native']}</legend>
			{$admtext['rrams-nativethumbhint']}&nbsp;<input type='button' value='Apply'
			class='small' onclick='return rramsSetNativeThumb()'></fieldset>\n";
		echo "<fieldset id='rramsRecommendedThumbHint' style='display:none;'>
			<legend>{$admtext['rrams-recommended']}</legend>
			{$admtext['rrams-recommendedthumbhint']}&nbsp;<input type='button' value='Apply' 
			class='small' onclick='return rramsSetRecommendedThumb()'></fieldset>\n";

		###Block of fields subordinate to and toggled by the "Extra Thumnail Information" buttons
		echo "<div class='rramsThumb' style='margin-left:2em;display:none;'>\n";
			###Display Media Filetypes
			if ($rrconfig['MediaThumbFiletypes']) {$checkedy=' checked'; $checkedn='';}
			else {$checkedy=''; $checkedn=' checked';}
			echo "<div>{$admtext['rrams-pathextprompt']}:
			<label class='rramsRecommended'><input type='radio' name='rrconfig[MediaThumbFiletypes]'
				value='1'$checkedy >{$admtext['yes']}</label>
			<label class='rramsNative'><input type='radio' name='rrconfig[MediaThumbFiletypes]'
				value='0'$checkedn>{$admtext['no']}</label>
			</div>\n";
			###Look for thumbnail file extension errors
			if ($rrconfig['MediaThumbExtErrors']) {$checkedy=' checked'; $checkedn='';}
			else {$checkedy=''; $checkedn=' checked';}
			echo "<div>{$admtext['rrams-thumbexterrprompt']}:
			<label class='rramsRecommended'><input type='radio' name='rrconfig[MediaThumbExtErrors]'
				value='1'$checkedy >{$admtext['yes']}</label>
			<label class='rramsNative'><input type='radio' name='rrconfig[MediaThumbExtErrors]'
				value='0'$checkedn>{$admtext['no']}</label>
			</div>\n";
			###Look for path FORM errors
			if ($rrconfig['MediaThumbFormErrors']) {$checkedy=' checked'; $checkedn='';}
			else {$checkedy=''; $checkedn=' checked';}
			echo "<div>{$admtext['rrams-pathformerrprompt']}:
			<label class='rramsRecommended'><input type='radio' name='rrconfig[MediaThumbFormErrors]'
				value='1'$checkedy >{$admtext['yes']}</label>
			<label class='rramsNative'><input type='radio' name='rrconfig[MediaThumbFormErrors]'
				value='0'$checkedn>{$admtext['no']}</label>
			</div>\n";
		echo "</div>\n"; #End Extra Thumbnail Info options
	echo "</td></tr>\n";

	##########################################################
	############# Citation Medialink Event Tags  #############
	#########################################################
	### One mod option, with 4 radio buttons
	echo "<tr><td style='border:2px solid green; text-align:left;'>
			7. {$admtext['rrams-eventtags']}:<br>
			<input type='button' class='small' value='{$admtext['rrams-seenative']}' 
				id='rramsNativeCiteButton'
				onclick=\"$('#rramsNativeCiteHint').toggle();\">
			&ensp;<input type='button' class='small' value='{$admtext['rrams-seerecommended']}' 
				id='rramsRecommendedCiteButton'
				onclick=\"$('#rramsRecommendedCiteHint').toggle();\">\n";
			#The show and hide buttons
			echo "&ensp;<input type='button' class='rramsCite small' 
				value='{$admtext['rrams-showsettings']}' onclick='rramsToggleCite();'>
			<input type='button' class='rramsCite small' value='{$admtext['rrams-hidesettings']}'
				onclick='rramsToggleCite();' style='display:none;'>\n";
		#Hint text for the Native Settings and Recommended Settings buttons.
		echo "<fieldset id='rramsNativeCiteHint' style='display:none;'>
			<legend>{$admtext['rrams-native']}</legend>
			{$admtext['rrams-nativecitehint']}&nbsp;<input type='button' value='Apply'
			class='small' onclick='return rramsSetNativeCite()'></fieldset>\n";
		echo "<fieldset id='rramsRecommendedCiteHint' style='display:none;'>
			<legend>{$admtext['rrams-recommended']}</legend>
			{$admtext['rrams-recommendedcitehint']}&nbsp;<input type='button' value='Apply' 
			class='small' onclick='return rramsSetRecommendedCite()'></fieldset>\n";

		###Four radio buttons in the "Citation Event Tags" section.
		echo "<div class='rramsCite' style='margin-left:2em;display:none;'>\n";
			$checked = ($rrconfig['MediaShowCiteTags']=='never') ? ' checked' : '';
			echo "<label class='rramsNative'><input type='radio' name='rrconfig[MediaShowCiteTags]'
				id='rramsCiteNever' value='never'$checked >{$admtext['rrams-citenever']}</label>\n";
			$checked = ($rrconfig['MediaShowCiteTags']=='always') ? ' checked' : '';
			echo "<br><label><input type='radio' name='rrconfig[MediaShowCiteTags]'
				value='always'$checked >{$admtext['rrams-citealways']}</label>\n";
			$checked = ($rrconfig['MediaShowCiteTags']=='togglestart') ? ' checked' : '';
			echo "<br><label><input type='radio' name='rrconfig[MediaShowCiteTags]'
				value='togglestart'$checked >{$admtext['rrams-citetogglestart']}</label>\n";
			$checked = ($rrconfig['MediaShowCiteTags']=='togglenot') ? ' checked' : '';
			echo "<br><label><input type='radio' name='rrconfig[MediaShowCiteTags]'
				id='rramsCiteWithout' value='togglenot'$checked >{$admtext['rrams-citetogglenot']}</label>\n";
		echo "</div>
	</td></tr>\n";
echo "</table>\n";

##################################################################
# Structural function to display the table that contains options for the searchable fields.
#In the first column:
# 1. The prompt for the searchable fields, referring to the fieldname/default flag table
# 2. A table containing the prompts and checkboxes for
#   - Whether to display the fieldnames in the search screen
#   - Whether to display checkboxes for the fieldnames in the search screen
#In the second column,
# 1. A table for the searchable fields
#   - 3 columns: Fieldname, checkbox indicating if it is searched by default, and a 'remove' button.
#   - 1 row for each searchable field
# 2.A selection box to select another field to put in the table and an Add Searchable Field button.
# These options are complicated by the fact that some options hide other options.
# This entire table row is hidden if the "Change searchable fields" option is offered
# 1. If the 'Change searchable fields' option above this table row is unchecked, this entire
#    table row is hidden, and all of its options are ignored by admin_search.php.
# 2. Within this table row, if the option "Display searchable fieldnames on the search form" is
#    unchecked, the option "Show checkboxes next to the fieldnames" is hidden, and it is
#    unchecked, and the ('fieldname is checked by default') column of the fieldname/checked
#    column is hidden.
# 3. If the option "Show checkboxes next to the fieldnames" is visible but not checked, the
#    second column of the searchable fields table ('fieldname is checked by default') is hidden.
####
function rrDisplaySearchTable() {
	global $rrconfig, $admtext;

	echo "<table><tr><td class='normal'>\n";
		echo "<div class='rramsSearchPromptYes'>{$admtext['rrams-searchablepromptyes']}:
			<p>{$admtext['rrams-searchablehintyes']}</p></div>\n";
		echo "<div class='rramsSearchPromptNo'>{$admtext['rrams-searchablepromptno']}:
			<p>{$admtext['rrams-searchablehintno']}</p></div>\n";
		echo "<p>{$admtext['rrams-searchablehintboth']}</p>\n";
	echo "</td><td>\n";
		#The inner table with the fieldnames and checkboxes
		echo "<table id='rramsSearchTable' class='normal'>
			<thead><tr>
				<td>{$admtext['rrams-fieldname']}</td>
				<td>{$admtext['default']}</td>
				<td style='display:none;' id='rramsRemove'>{$admtext['remove']}</td>
			</tr></thead>
			<tbody>\n";
			$rramsFieldnames = explode(',', $rrconfig['MediaSearchableFields']);
			$rramsDefaultFields = explode(',', $rrconfig['MediaSearchDefault']);
			for ($rr=0; $rr<count($rramsFieldnames); $rr++) {
				$rramsFieldname = $rramsFieldnames[$rr];
				$checked = (in_array($rramsFieldname, $rramsDefaultFields)!==false) ? ' checked' : '';
				echo "<tr id='rrmsdbrow$rr'><td>$rramsFieldname
					<input type='hidden' name='rrMediaSearchableFieldList[$rr]'
						id='rramsfname$rr' value='$rramsFieldname'></td>
					<td class='rrMediaShowSearchCheckboxes'><input type='checkbox'
						name='rrMediaSearchDefault[$rr]' id='rrmsfcheckbox$rr'
						value='$rramsFieldname'$checked></td>
					<td><input type='button' class='smaller' id='remove$rr'
						value='{$admtext['remove']}' onclick='return rramsRemoveSearchField($rr);'></td>
					</tr>\n";
			}
			echo "</tbody></table>\n"; #End the inner layout table of search fields

			#Populate the "Select a fieldname" selection box with all varchar and int checkboxes
			#that are not already in the search fields table.
			$rrsql = "SHOW COLUMNS FROM {$GLOBALS['media_table']}";
			$rrresult = tng_query($rrsql);
			while( $rrrow = tng_fetch_assoc($rrresult) ) {
				$rrfieldname = $rrrow['Field'];
				$rrtype = $rrrow['Type'];
				if (($rrtype=='text' || substr($rrtype,0,7)=='varchar' || substr($rrtype,0,4)=='int(')
					&& array_search($rrfieldname, $rramsFieldnames) === false)
					$rramsoptions .= "<option>$rrfieldname</option>\n";
			}
			#Add the fieldname selection list and "Add Searchable Field" button below the table
			echo "<select name='rramsNewFieldname' id='rramsNewFieldname' onchange='rramsValidateNewFields();'>
				<option value=''>{$admtext['rrams-selectfield']}</option>
				$rramsoptions</select>
				<input type='button' id='rramsAddButton' disabled
					onclick=\"return rramsAddSearchableField($('#rramsNewFieldname').val());\"
					disabled value='{$admtext['rrams-addsearchable']}'>\n";
	echo "</td></tr>
		</table>\n"; #The floating div containing the inner table
} #end function rrDisplaySearchTable

##################################################################
# PHP function to display the table row that handles options for the optional results columns
#In the first column:
# - The prompt for the searchable fields and whether they are displayed:
#In the second column,
# - A table for the searchable fields, with
#   - 3 columns: Fieldname, checkbox indicating if it is searched by default, and a 'remove' button.
#   - 1 row for each searchable field
# - A selection box to select another field to put in the table and an Add Searchable Field button.
# Options that hide options:
# This entire table row is hidden if the "Change searchable fields" option is offer
# Within this table row, if the option "Display searchable fieldnames on the search form" is unchecked,
# the option "Show checkboxes next to the fieldnames" is hidden.
# And if the option "Show checkboxes next to the fieldnames" is not checked, the second column
# of the searchable fields table ('fieldname is checked by default') is hidden.
# There's a complication in that if the option "Display searchable fieldnames on the search form" is
# unchecked, we also need to uncheck the 'fieldname is checked by default' column.
####
function rrDisplayColumnsOptions() {
	global $rrconfig, $admtext;
	$rramsPossibleColumns = explode(',', 'mediaid,mediakey,path,geocodes');
	$rramsOfferedColumns = explode(',', $rrconfig['MediaOfferedColumns']);
	$rramsDefaultColumns = explode(',', $rrconfig['MediaDefaultColumns']);
	#Put the Optional Columns table and its prompt in two columns of a layout table
	echo "<table class='normal rramsColumnsYes'><tr><td>{$admtext['rrams-resultsyeshint']}\n";
	echo "</td><td>";
		#Table where the rows have optional column names, "offered" checkbox, and "default" checkbox
		#Unlike the optional search fields, there is a fixed set of optional columns, though
		#they are defined in an option.
		echo "<table id='rramsColumnsTable' class='normal'>
			<thead><tr>
				<td>{$admtext['rrams-columnname']}</td>
				<td>{$admtext['rrams-offered']}</td>
				<td>{$admtext['default']}</td>
			</tr></thead>
			<tbody>\n";
			for ($rr=0; $rr<count($rramsPossibleColumns); $rr++) {
				$rramsColumn = $rramsPossibleColumns[$rr];
				if (empty($admtext['rrams-'.$rramsColumn])) $rramsDisplay = $rramsColumn;
				else $rramsDisplay = $admtext['rrams-'.$rramsColumn];
				$checked1 = (in_array($rramsColumn, $rramsOfferedColumns)!==false) ? ' checked' : '';
				$checked2 = (in_array($rramsColumn, $rramsDefaultColumns)!==false) ? ' checked' : '';
				echo "<tr><td>$rramsDisplay
					<input type='hidden' name='rramsPossibleColumns[$rr]'
						value='$rramsColumn'></td>
					<td><input type='checkbox' name='rramsOfferedColumns[$rr]'
						class='rramsOfferedColumns' id='rramsOffered{$rramsPossibleColumns[$rr]}'
						value='$rramsColumn'$checked1></td>
					<td><input type='checkbox' name='rramsDefaultColumns[$rr]'
						class='rramsDefaultColumns' id='rramsDefault{$rramsPossibleColumns[$rr]}'
						value='$rramsColumn'$checked2></td>
					</tr>\n";
			}
			echo "</tbody></table>\n"; //End the result columns table
	echo "</td></tr>
	</table>\n"; #End the layout table that holds the result columns table.
} #End function rrDisplayColumnsOptions
################################################################

echo "<style>
.rramsOptionPrompt {max-width:350px;}
.rramsOptionHint {max-width:90%; text-align:left; margin-top:1ex;}
#rramsSearchTable {border-spacing:0; border-collapse:collapse;}
#rramsSearchTable>thead>tr>td {border:1px solid grey; padding:1px 2px;}
#rramsSearchTable>tbody>tr>td {border:1px solid grey; padding:1px 2px;}
#rramsColumnsTable {border-spacing:0; border-collapse:collapse;}
#rramsColumnsTable>thead>tr>td {border:1px solid grey; padding:1px 2px;}
#rramsColumnsTable>tbody>tr>td {border:1px solid grey; padding:1px 2px;}
.rramsDisabled {color:#aaa;}
.rrams fieldset {padding:2px 3px;}
.rrams fieldset>legend {font-weight:bold; font-size:92%;}
</style>\n";
?>
